var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { getClassName } from '@react-devui/utils';
import { TTANSITION_DURING_FAST } from '../../utils';
import { DTransition } from '../_transition';
import { usePrefixConfig } from '../root';
export function DMask(props) {
    const { dVisible, onClose, afterVisibleChange } = props, restProps = __rest(props, ["dVisible", "onClose", "afterVisibleChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const transitionStyles = {
        enter: { opacity: 0 },
        entering: {
            transition: ['opacity'].map((attr) => `${attr} ${TTANSITION_DURING_FAST}ms linear`).join(', '),
        },
        leaving: {
            opacity: 0,
            transition: ['opacity'].map((attr) => `${attr} ${TTANSITION_DURING_FAST}ms linear`).join(', '),
        },
        leaved: { display: 'none' },
    };
    return (_jsx(DTransition, Object.assign({ dIn: dVisible, dDuring: TTANSITION_DURING_FAST, 
        // TODO: Should it be controllable?
        dSkipFirstTransition: false, afterEnter: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
        }, afterLeave: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
        } }, { children: (state) => (_jsx("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}mask`), style: Object.assign(Object.assign({}, restProps.style), transitionStyles[state]), onClick: (e) => {
                var _a;
                (_a = restProps.onClick) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                onClose === null || onClose === void 0 ? void 0 : onClose();
            } }))) })));
}
