import React from 'react';
export interface DSubProps {
    children: React.ReactNode;
    dId: string;
    dLevel: number;
    dIcon: React.ReactNode | undefined;
    dList: React.ReactNode;
    dPopupState: boolean | undefined;
    dTrigger: 'hover' | 'click';
    dZIndex: number | string | undefined;
    dEmpty: boolean;
    dFocusVisible: boolean;
    dDisabled: boolean;
    onVisibleChange: (visible: boolean) => void;
}
export declare const DSub: React.ForwardRefExoticComponent<DSubProps & React.RefAttributes<() => void>>;
