import React from 'react';
export interface DPanelProps {
    dTime: Date | null;
    dCols: ('hour' | 'minute' | 'second')[];
    d12Hour: boolean;
    dConfigTime: ((unit: 'hour' | 'minute' | 'second', value: number) => {
        disabled?: boolean;
        hidden?: boolean;
    }) | undefined;
    onTimeChange: ((time: Date) => void) | undefined;
}
export interface DPanelPrivateProps {
    __header?: boolean;
}
export declare const DPanel: React.ForwardRefExoticComponent<DPanelProps & React.RefAttributes<(date: Date) => void>>;
